'ver 1.21
'---------------------------------------------------------------------------
                                                       
'ver 1.01 12/22/2019
'- darkened frame by removing theme for it
'- limited generated characters to (33-126) 
'  and defined array sym() for symbol characters
'- added opening password and verification          
'ver 1.02 12/23/2019                                                    
'- added "Clear fields" button                          
'ver 1.03 12/26/2019
'- put minimizebox on title bar and removed minimize button
'- added dlgHt varible to change height of dialog (compacting dialog)
'- added "Add/Update" button next to ""Open URL" button
'- capitalize first character of websiteName(i) and sort listbox 
'- sorting listbox requires LISTBOX SET USER statements
'- launch help file with "F1 for help" shown in first part of statusbar                      
'- also added version label at bottom of dialog
'- allow double clicking "Add/Update" button to keep expanded dialog
'ver 1.04 01/03/2020
'- added checkbox to change master password in verifyPassword 
'- added feature to limit symbols to only ones specified in password field
'- exiting program, added cancel: YES,NO,CANCEL
'- "Open URL", "Copy username", and "Copy password" uses text from data fields
'ver 1.05 01/18/2020 
'- changed "Remove" button to "Replace" and "Add" or "Update" button to just Add        
'- add right click floating menu [Remove] instead of "remove" button
'- open URL on double click of list item (same as "Open URL" button
'- added statusbar at bottom [F1 Help    xx sites   Ver 1.05] 
'- changed %IDC_EditData to %IDC_ShowData button and "Add/Update" to "Show data"
'- append "*" to "Copy username" and "Copy password" buttons when copied to clipboard       
'- other changes associated with displaying the program (aesthetic reasons only) 
'- improved readability of code with showData flag variable
'ver 1.06 03/26/2020
'- added two buttons, [Add URL] and [Edit data]
'- changed [Show data] button text to [View data] and removed dblclick from it
'- made viewed data read only (WebsiteName1, WebsiteURL1, UserName1, Password1 fields)          
'- added [Back] button to expanded form (collapses form when clicked)
'- added [Remove] button in expanded form after clicking [Edit data] button
'- used array storPtr() to detect when form fields are changed
'ver 1.07 04/14/2020
'- put opening verifyPassword dialog in closer proximity to main dialog
'- set window to topmost position in z-order using exStyle = %WS_EX_TOPMOST      
'- added accelerator keys F1 Help and F2 File (F2 shows data file location)
'- add sub dataFileLoc()... responds to F2 to show data file's full name and path)
'- uses file myPassword.ini to keep last saved data file (see openIniFile() and saveIniFile)
'ver 1.08 04/30/2020
'- fixed problem loading last file (iniFile saved before only if data file was changed)
'ver 1.09 11/08/2020
'- add version to title, change statusbar to add F3 for saving data file                                 
'- added 'More data' textbox for PIN numbers and security answers
'ver 1.10 11/10/2020
'- corrected error ending SetPasswordProc: must use GLOBAL pwFile in STRPTR(pwFile)
'- strengthened generated passwords
'ver 1.11 11/30/2020
'- fixed detecting field changes using fieldText() instead of storPt()
'- improved Exiting program when form is expanded in %IDC_AddURL and %IDC_EditData
'- checkbox for showing password when setting and verifying
'- click [Gen password] again to show original password when editing
'ver 1.12 12/12/2020
'- add "www." when missing in URL address
'- F3 Save does not need "Cancel" in msgbox     
'- enable/disable "Open URL", "Copy username", "Copy password" if fields are filled or not
'ver 1.13 12/15/2020
'- added %IDC_ExpandForm and %IDC_CollapseForm for improved code
'- fixed problem showing enabled/disabled buttons OpenURL, CopyUser, CopyPassword
'- improved code for "generatePassword"
'ver 1.15 03/10/2021
'- corrected problem of password and moreData as encrypted after F3_save
'ver 1.16 10/22/2021
'- changed "more data" from a single line textbox to a button that brings up a six line textbox                                           
'ver 1.17 12/17/2021
'- disabled "GenPassword" button when "more data" textbox is shown
'ver 1.18 01/18/2022
'- enabled "GenPassword" button when %IDC_ExpandForm is clicked
'ver 1.20 01/25/2022
'- view mode to allow scrolling the main window
'- allow password generation only when password textbox has focus
'- corrected problem prompting erroneously that data file had been changed
'ver 1.21 02/03/2022
'- subclassed listbox to not allow other selected items when item is edited
'- corrected problem with variable last = 0 when adding new item
'- corrected aesthetic problem with view mode changing after more data shown
'ver 1.22 08/03/2022
'- corrected Copy UserName and Copy Password when expanded form                                         
'-------------------------------------------------------------------------------------------------
      
%IDC_ListWebsiteNames = 101                        
%IDC_OpenURL          = 102                                                                 
%IDC_ViewData         = 103
%IDC_AddURL           = 104
%IDC_EditData         = 105
%IDC_Frame            = 110 'form fields
%IDC_Back             = 111
%IDC_WebsiteName      = 112 'form fields
%IDC_WebsiteURL       = 113 'form fields
%IDC_UserName         = 114 'form fields
%IDC_Password         = 115 'form fields
%IDC_MoreData         = 116 'form fields
%IDC_WebsiteName1     = 121 'read only form fields 
%IDC_WebsiteURL1      = 122 'read only form fields
%IDC_UserName1        = 123 'read only form fields
%IDC_Password1        = 124 'read only form fields
%IDC_MoreData1        = 125 'read only form fields
%IDC_MoreDataBtn      = 130 'button for moreData form fields

%IDC_GenPassword      = 141
%IDC_Exec             = 142
%IDC_CopyUsername     = 143                 
%IDC_CopyPassword     = 144
%IDC_Status           = 145
%IDC_ClrFields        = 146
%IDC_ExpandForm       = 147
%IDC_CollapseForm     = 148 

%IDC_ChangePW         = 161
%IDC_ShowPW           = 162           
%IDC_Confirm          = 163
%IDC_Confirm1         = 164

%IDM_Remove           = 190 'listbox menu for right click               
%IDC_F1               = 201
%IDC_F2               = 202
%IDC_FF1              = 203
%IDC_FF2              = 204       
                                                                       
                                                                                        
global hDlg, dlgWi, dlgHt, num, showPW, toSave, moreDataToggle as long
global dataMode, gOldWindowProc as long
global helpFile, thisFile, pwFile, pwEmer, dataFolder, execName as string 
global websiteName(), websiteURL(), userName(), password(), moreData() as string
global origText() as string

'storPtr() used to hold form data and signal when edited
'dataMode = 0  form not expanded
'         = 1  form expanded by [View data] button
'         = 2  form expanded by [Add URL] button
'         = 3  form expanded by [Edit data] button


                                                                                              
